#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include <string.h>
#include <omp.h>
#include <cilk/cilk.h>
#include <cilk/cilk_api.h>

int const n = 500;
int dist[n][n];

void work(int k, int i)
{	
	for (int j = 0; j < n; ++j)
		if ((dist[i][k] * dist[k][j] != 0) && (i != j))
			if ((dist[i][k] + dist[k][j] < dist[i][j]) ||
				(dist[i][j] == 0))
					dist[i][j] = dist[i][k] + dist[k][j];
}

void floyd_warshall() {
	for (int k = 0; k < n; ++k) 
		for (int i = 0; i < n; ++i)
			cilk_spawn work(k,i);
}

int main(int argc, char *argv[]) {
	__cilkrts_set_param("nworkers","4");
	srand(time(NULL));
	int i, j;
	for (i = 0; i < n; ++i)
		for (j = 0; j < n; ++j)
		{
			if(i!=j)
				dist[i][j]=rand()%130;
			else
				dist[i][j]=0;
		}
	double st = omp_get_wtime();
	floyd_warshall();
	double fn = omp_get_wtime();
	printf("Time is %f seconds\n", fn - st);
}
