#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include <string.h>
#include <omp.h>

int const n = 500;
int dist[n][n];

void work(int k, int i)
{	

			for (int j = 0; j < n; ++j)
				if ((dist[i][k] * dist[k][j] != 0) && (i != j))
					if ((dist[i][k] + dist[k][j] < dist[i][j]) ||
						(dist[i][j] == 0))
						dist[i][j] = dist[i][k] + dist[k][j];
}

void floyd_warshall() {
	for (int k = 0; k < n; ++k) 
			for (int i = 0; i < n; ++i)
				work(k,i );
}

int main(int argc, char *argv[]) {
	srand(time(NULL));
	int i, j;
	for (i = 0; i < n; ++i)
		for (j = 0; j < n; ++j)
		{
			if(i!=j)
				dist[i][j]=rand()%130;
			else
				dist[i][j]=0;
		}
	double st = omp_get_wtime();
	floyd_warshall();
	double fn = omp_get_wtime();
	printf("Time is %f seconds\n", fn - st);
}